; Compare DefWindow and Undocumented EditBox
; (masm32)

.386
.model flat,stdcall
option casemap: none

inclib macro x
 include x.inc
 includelib x.lib
endm

include windows.inc
inclib user32
inclib kernel32
inclib gdi32
inclib comctl32

.const
  STAP_ALLOW_NONCLIENT  equ 1
  STAP_ALLOW_CONTROLS   equ 2
  STAP_ALLOW_WEBCONTENT equ 4
  WM_THEMECHANGED       equ 031Ah
  id                    equ 3000
.data
  _0     db "DefWindow",0
  _about db "by kero <geocities.com/xmemor>, v.2008-05-11",0
  _2     db "SendMessage  (WM_SETTEXT)",0
  _20    db "SendMessage  (WM_GETTEXT)",0
  _3     db "SetWindowText",0
  _30    db "GetWindow"
  _1     db "Text",0
  _4     db "EditProc / DefWindowProc  (WM_SETTEXT)",0
  _5     db "EditProc / DefWindowProc  (WM_GETTEXT)",0
  _6     db "STAP_ALLOW_NONCLIENT  on/off",0
  _edt   db "EDIT",0
  _btn   db "BUTTON",0
  _UT    db "UxTheme",0
  _ITA   db "IsThemeActive",0
  _STAP  db "SetThemeAppProperties",0
  _GTAP  db "GetThemeAppProperties",0 
  _ds    db "(%d)  %s",0
  lf     LOGFONT <-11,0,0,0,400,0,0,0,1,0,0,0,0,"Tahoma">
  getset db 0
  edproc dd 0
  count  dd 0
  _cla   db "CLASS",0
.data?
.code

WinFromPt proc uses ebx
  local pt:POINT
  invoke GetCursorPos,addr pt
  invoke WindowFromPoint,pt.x,pt.y
  mov ebx,eax    
  invoke GetKeyState,VK_CONTROL ; CTRL key
  and eax,8000h
  .if eax!=0 ; root of window beneath cursor
    invoke GetAncestor,ebx,GA_ROOT
  .else ; window beneath cursor
    mov eax,ebx
  .endif
  ret
WinFromPt endp


STAP proc uses ebx hWnd:HWND
  invoke GetModuleHandle,offset _UT
  mov ebx,eax
  .if eax!=0
    invoke GetProcAddress,ebx,offset _ITA
    call eax
    .if eax==TRUE
      invoke GetProcAddress,ebx,offset _GTAP
      call eax
      mov ecx,eax
      or eax,STAP_ALLOW_NONCLIENT  ; STAP_ALLOW_CONTROLS OR STAP_ALLOW_WEBCONTENT OR STAP_ALLOW_NONCLIENT
      .if eax==ecx
        and eax,not STAP_ALLOW_NONCLIENT
      .endif
      push eax
      invoke GetProcAddress,ebx,offset _STAP
      call eax
      invoke SendMessage,hWnd,WM_THEMECHANGED,0,0
    .endif
  .endif
  ret
STAP endp


WndProc proc uses ebx hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
  local buff[256]:BYTE
  local buf[128]:BYTE

  .if uMsg==WM_DESTROY
    invoke PostQuitMessage,0
    xor eax,eax

  .elseif uMsg==WM_CTLCOLORSTATIC
    invoke GetStockObject,WHITE_BRUSH

  .elseif uMsg==WM_COMMAND
    mov eax,wParam
    .if eax==id+2 || eax==id+3    
      invoke WinFromPt
      mov ebx,eax      
      .if getset!=0  ; GetText
        .if wParam==id+2
          invoke SendMessageTimeout,ebx,WM_GETTEXT,255,addr buff,SMTO_ABORTIFHUNG,300,0
        .else
          invoke GetWindowText,ebx,addr buff,255
        .endif
        invoke SendDlgItemMessage,hWnd,id+1,WM_SETTEXT,0,addr buff
      .else  ; SetText
        .if ebx==lParam
          mov ebx,hWnd
        .endif
        invoke SendDlgItemMessage,hWnd,id+1,WM_GETTEXT,127,addr buf
        mov ecx,count
        inc count
        invoke wsprintf,addr buff,offset _ds,ecx,addr buf
        .if wParam==id+2
          invoke SendMessageTimeout,ebx,WM_SETTEXT,0,addr buff,SMTO_ABORTIFHUNG,300,0
        .else
          invoke SetWindowText,ebx,addr buff
        .endif
      .endif
    .elseif eax==id+6
      invoke STAP,hWnd
      mov ebx,hWnd
    .elseif eax==id+4 || eax==id+5
      mov ebx,hWnd
    .endif
    invoke SetWindowPos,ebx,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED OR SWP_NOACTIVATE
    xor eax,eax

  .elseif uMsg==WM_CONTEXTMENU
;    invoke DefWindowProc,hWnd,WM_NCHITTEST,0,lParam
;    mov ecx,wParam
;    .if eax==HTCLIENT && ecx==hWnd
;      jmp @cwp
;    .endif
    invoke GetWindowLong,wParam,GWL_ID
    .if eax==id+2 || eax==id+3
      xor getset,1
      .if getset!=0
        mov ecx,offset _20
        mov ebx,offset _30
      .else
        mov ecx,offset _2
        mov ebx,offset _3
      .endif
      invoke SendDlgItemMessage,hWnd,id+2,WM_SETTEXT,0,ecx
      invoke SendDlgItemMessage,hWnd,id+3,WM_SETTEXT,0,ebx
    .endif
    jmp @dwp

  .elseif uMsg==WM_SETTEXT
    mov eax,id+4
    jmp @f
  .elseif uMsg==WM_GETTEXT
    mov eax,id+5
@@:
    invoke SendDlgItemMessage,hWnd,eax,BM_GETCHECK,0,0
    .if eax!=BST_CHECKED
      jmp @dwp
    .else
@cwp:
      invoke CallWindowProc,edproc,hWnd,uMsg,wParam,lParam
    .endif
  .else
@dwp:
    invoke DefWindowProc,hWnd,uMsg,wParam,lParam
  .endif
  ret
WndProc endp

WinMain proc uses ebx hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
  local msg:MSG
  local	wc:WNDCLASSEX
  local hfont:HFONT
  mov	wc.cbSize,sizeof wc
  mov	wc.style,CS_DBLCLKS
  mov	wc.lpfnWndProc,offset WndProc
  mov	wc.cbClsExtra,0
  mov	wc.cbWndExtra,0
  mov	eax,hInst
  mov	wc.hInstance,eax
  mov	wc.hbrBackground,COLOR_WINDOW+1
  mov	wc.lpszMenuName,0
  mov	wc.lpszClassName,offset _cla
  invoke LoadIcon,0,IDI_APPLICATION
  mov	wc.hIcon,eax
  mov	wc.hIconSm,eax
  invoke LoadCursor,0,IDC_ARROW
  mov	wc.hCursor,eax
  invoke RegisterClassEx,addr wc
  invoke CreateWindowEx,WS_EX_TOPMOST OR WS_EX_CLIENTEDGE,offset _cla,offset _0,WS_OVERLAPPEDWINDOW OR WS_CLIPCHILDREN,20,20,280,230,0,0,hInst,0
  mov ebx,eax
  invoke GetClassInfoEx,NULL,offset _edt,addr wc
  mov eax,wc.lpfnWndProc
  mov edproc,eax
  push ebx
  push ebx  
  invoke CreateWindowEx,0,offset _edt,offset _1,WS_CHILD OR WS_VISIBLE OR WS_TABSTOP OR ES_AUTOHSCROLL OR WS_BORDER,20,26,230,22,ebx,id+1,hInst,0  ; (test WS_BORDER !)
  push eax
  invoke SetFocus,eax
  invoke CreateWindowEx,0,offset _btn,offset _2,WS_CHILD OR WS_VISIBLE OR WS_TABSTOP,20,51,230,23,ebx,id+2,hInst,0
  push eax
  invoke CreateWindowEx,0,offset _btn,offset _3,WS_CHILD OR WS_VISIBLE OR WS_TABSTOP,20,77,230,23,ebx,id+3,hInst,0
  push eax
  invoke CreateWindowEx,0,offset _btn,offset _4,WS_CHILD OR WS_VISIBLE OR WS_TABSTOP OR BS_AUTOCHECKBOX,20,101,230,23,ebx,id+4,hInst,0
  push eax
  invoke CreateWindowEx,0,offset _btn,offset _5,WS_CHILD OR WS_VISIBLE OR WS_TABSTOP OR BS_AUTOCHECKBOX,20,124,230,23,ebx,id+5,hInst,0
  push eax
  invoke CreateWindowEx,0,offset _btn,offset _6,WS_CHILD OR WS_VISIBLE OR WS_TABSTOP,20,150,230,23,ebx,id+6,hInst,0
  push eax
  xor ebx,ebx
  invoke CreateFontIndirect,offset lf
  mov hfont,eax  
  .while ebx<=6
    pop ecx
    invoke SendMessage,ecx,WM_SETFONT,hfont,0
    inc ebx
  .endw
  pop ebx
  invoke ShowWindow,ebx,CmdShow
  invoke UpdateWindow,ebx
  .while TRUE
    invoke GetMessage,addr msg,0,0,0
    .break .if (!eax)
    invoke IsDialogMessage,ebx,addr msg
    .if eax==FALSE
      invoke TranslateMessage,addr msg
      invoke DispatchMessage,addr msg
    .endif
  .endw
  invoke DeleteObject,hfont
  mov	eax,msg.wParam
  ret
WinMain endp

start:
  invoke GetModuleHandle,0
  invoke WinMain,eax,0,0,SW_SHOWDEFAULT
  invoke ExitProcess,eax
  invoke InitCommonControls  
end start
