; Undocumented EditBox
; (masm32)

.386
.model flat,stdcall
option casemap: none

inclib macro x
 include x.inc
 includelib x.lib
endm

include windows.inc
inclib user32
inclib kernel32
inclib gdi32
inclib comctl32

GUITHREADINFO struct
    cbSize         DWORD ?
    flags          DWORD ?
    hwndActive     HWND ?
    hwndFocus      HWND ?
    hwndCapture    HWND ?
    hwndMenuOwner  HWND ?
    hwndMoveSize   HWND ?
    hwndCaret      HWND ?
    rcCaret        RECT <>
GUITHREADINFO ends

.const
  STAP_ALLOW_NONCLIENT  equ 1
  STAP_ALLOW_CONTROLS   equ 2
  STAP_ALLOW_WEBCONTENT equ 4
  WM_THEMECHANGED       equ 031Ah
  id                    equ 3000
  idm                   equ SC_SCREENSAVE

.data
  _0     db "Undocumented  EditBox",0
  _about db "v.2008-05-13, by kero",0," <geocities.com/xmemor>",0
  _2     db "SendMessage  (WM_SETTEXT)",0
  _20    db "SendMessage  (WM_GETTEXT)",0
  _3     db "SetWindowText",0
  _30    db "GetWindow"
  _1     db "Text",0
  _4     db "EditProc / DefWindowProc  (WM_SETTEXT)",0    
  _5     db "EditProc / DefWindowProc  (WM_GETTEXT)",0
  _6     db "STAP_ALLOW_NONCLIENT  on/off",0
  _edt   db "EDIT",0
  _btn   db "BUTTON",0
  _UT    db "UxTheme",0
  _ITA   db "IsThemeActive",0
  _STAP  db "SetThemeAppProperties",0
  _GTAP  db "GetThemeAppProperties",0
  _ds    db "(%d)  %s",0
  lf     LOGFONT <-11,0,0,0,400,0,0,0,1,0,0,0,0,"Tahoma">
  getset dd 0
  edproc dd 0
  count  dd 0
.data?
.code

WinFromPt proc uses ebx
  local pt:POINT
  invoke GetCursorPos,addr pt
  invoke WindowFromPoint,pt.x,pt.y
  mov ebx,eax    
  invoke GetKeyState,VK_CONTROL ; CTRL key
  and eax,8000h
  .if eax!=0 ; root of window beneath cursor
    invoke GetAncestor,ebx,GA_ROOT
  .else ; window beneath cursor
    mov eax,ebx
  .endif
  ret
WinFromPt endp

STAP proc uses ebx hWnd:HWND
  invoke GetModuleHandle,offset _UT
  mov ebx,eax
  .if eax!=0
    invoke GetProcAddress,ebx,offset _ITA
    call eax
    .if eax==TRUE
      invoke GetProcAddress,ebx,offset _GTAP
      call eax
      mov ecx,eax
      or eax,STAP_ALLOW_NONCLIENT  ; STAP_ALLOW_CONTROLS OR STAP_ALLOW_WEBCONTENT OR STAP_ALLOW_NONCLIENT
      .if eax==ecx
        and eax,not STAP_ALLOW_NONCLIENT
      .endif
      push eax
      invoke GetProcAddress,ebx,offset _STAP
      call eax
      invoke SendMessage,hWnd,WM_THEMECHANGED,0,0
    .endif
  .endif
  ret
STAP endp


WndProc proc uses ebx hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
  local buff[256]:BYTE
  local buf[128]:BYTE
  local pt:POINT

  .if uMsg==WM_DESTROY
    invoke PostQuitMessage,0
    xor eax,eax

  .elseif uMsg==WM_CTLCOLORSTATIC
    invoke GetStockObject,WHITE_BRUSH

  .elseif uMsg==WM_COMMAND
    mov eax,wParam
    .if eax==id+2 || eax==id+3    
      invoke WinFromPt
      mov ebx,eax      
      .if getset!=0  ; GetText
        .if wParam==id+2
          invoke SendMessageTimeout,ebx,WM_GETTEXT,255,addr buff,SMTO_ABORTIFHUNG,300,0
        .else
          invoke GetWindowText,ebx,addr buff,255
        .endif
        invoke SendDlgItemMessage,hWnd,id+1,WM_SETTEXT,0,addr buff
      .else  ; SetText
        .if ebx==lParam
          mov ebx,hWnd
        .endif
        invoke SendDlgItemMessage,hWnd,id+1,WM_GETTEXT,127,addr buf
        mov ecx,count
        inc count
        invoke wsprintf,addr buff,offset _ds,ecx,addr buf
        .if wParam==id+2
          invoke SendMessageTimeout,ebx,WM_SETTEXT,0,addr buff,SMTO_ABORTIFHUNG,300,0
        .else
          invoke SetWindowText,ebx,addr buff
        .endif
      .endif      
    .elseif eax==id+6
      invoke STAP,hWnd
      mov ebx,hWnd
    .elseif eax==id+4 || eax==id+5
      mov ebx,hWnd
    .endif
    invoke SetWindowPos,ebx,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED OR SWP_NOACTIVATE
    xor eax,eax

  .elseif uMsg==WM_KEYDOWN || uMsg==WM_KEYUP || uMsg==WM_CHAR || uMsg==WM_PASTE || uMsg==WM_CUT || uMsg==WM_CLEAR || uMsg==WM_UNDO
    invoke CallWindowProc,edproc,hWnd,uMsg,wParam,lParam
    invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED OR SWP_NOACTIVATE

  .elseif uMsg==WM_CONTEXTMENU
    mov eax,lParam
    mov ecx,eax
    and eax,0ffffh
    shr ecx,16
    mov pt.x,eax
    mov pt.y,ecx
    invoke ScreenToClient,hWnd,addr pt
    invoke DefWindowProc,hWnd,WM_NCHITTEST,0,lParam
    mov ecx,wParam
    .if eax==HTCLIENT && ecx==hWnd && pt.y>=0 && pt.y<=14
      jmp @cwp
    .endif
    invoke GetWindowLong,wParam,GWL_ID
    .if eax==id+2 || eax==id+3
      xor getset,1
      .if getset!=0
        mov ecx,offset _20
        mov ebx,offset _30
      .else
        mov ecx,offset _2
        mov ebx,offset _3
      .endif
      invoke SendDlgItemMessage,hWnd,id+2,WM_SETTEXT,0,ecx
      invoke SendDlgItemMessage,hWnd,id+3,WM_SETTEXT,0,ebx
    .endif
    jmp @dwp

  .elseif uMsg==WM_SETTEXT
    mov eax,id+4
    jmp @f
  .elseif uMsg==WM_GETTEXT
    mov eax,id+5
@@:
    invoke SendDlgItemMessage,hWnd,eax,BM_GETCHECK,0,0
    .if eax!=BST_CHECKED
@dwp:
      invoke DefWindowProc,hWnd,uMsg,wParam,lParam
    .else
      jmp @cwp
    .endif
  .else
@cwp:
    invoke CallWindowProc,edproc,hWnd,uMsg,wParam,lParam
  .endif
  ret
WndProc endp

WinMain proc uses ebx edi hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
  local msg:MSG
  local hfont:HFONT
  local guiti:GUITHREADINFO  
  invoke CreateWindowEx,WS_EX_TOPMOST OR WS_EX_CLIENTEDGE,offset _edt,offset _0,WS_OVERLAPPEDWINDOW OR WS_CLIPCHILDREN,20,20,280,230,0,0,hInst,0
  mov ebx,eax
  push ebx
  invoke SetWindowLong,ebx,GWL_WNDPROC,offset WndProc
  mov edproc,eax
  invoke GetClassLong,ebx,GCL_STYLE
  and eax,not CS_PARENTDC
  invoke SetClassLong,ebx,GCL_STYLE,eax
  invoke LoadCursor,0,IDC_ARROW
  invoke SetClassLong,ebx,GCL_HCURSOR,eax
  invoke CreateWindowEx,0,offset _edt,offset _1,WS_CHILD OR WS_VISIBLE OR WS_TABSTOP OR ES_AUTOHSCROLL OR WS_BORDER,20,26,230,22,ebx,id+1,hInst,0  ; (test WS_BORDER !)
  push eax
  invoke SetFocus,eax
  invoke CreateWindowEx,0,offset _btn,offset _2,WS_CHILD OR WS_VISIBLE OR WS_TABSTOP,20,51,230,23,ebx,id+2,hInst,0
  push eax
  invoke CreateWindowEx,0,offset _btn,offset _3,WS_CHILD OR WS_VISIBLE OR WS_TABSTOP,20,77,230,23,ebx,id+3,hInst,0
  push eax
  invoke CreateWindowEx,0,offset _btn,offset _4,WS_CHILD OR WS_VISIBLE OR WS_TABSTOP OR BS_AUTOCHECKBOX,20,101,230,23,ebx,id+4,hInst,0
  push eax
  invoke SendMessage,eax,BM_SETCHECK,BST_CHECKED,0
  invoke CreateWindowEx,0,offset _btn,offset _5,WS_CHILD OR WS_VISIBLE OR WS_TABSTOP OR BS_AUTOCHECKBOX,20,124,230,23,ebx,id+5,hInst,0
  push eax
  invoke SendMessage,eax,BM_SETCHECK,BST_CHECKED,0
  invoke CreateWindowEx,0,offset _btn,offset _6,WS_CHILD OR WS_VISIBLE OR WS_TABSTOP,20,150,230,23,ebx,id+6,hInst,0
  push eax    
  xor edi,edi
  invoke CreateFontIndirect,offset lf
  mov hfont,eax
  .while edi<=6
    pop ecx
    invoke SendMessage,ecx,WM_SETFONT,hfont,0
    inc edi
  .endw
  invoke GetSystemMenu,ebx,0
  mov edi,eax
  invoke AppendMenu,edi,MF_SEPARATOR,0,0
  invoke AppendMenu,edi,MF_STRING,idm,offset _about
  invoke ShowWindow,ebx,CmdShow
  invoke UpdateWindow,ebx
  invoke GetWindowThreadProcessId,ebx,0
  mov edi,eax
  mov guiti.cbSize,sizeof GUITHREADINFO
  .while TRUE
    invoke GetMessage,addr msg,0,0,0
    .break .if (!eax)
    invoke GetGUIThreadInfo,edi,addr guiti
    xor eax,eax    
    .if ebx!=guiti.hwndCaret
      invoke IsDialogMessage,ebx,addr msg
    .endif
    .if eax==FALSE
      invoke TranslateMessage,addr msg
      invoke DispatchMessage,addr msg
    .endif
  .endw
  invoke DeleteObject,hfont
  mov	eax,msg.wParam
  ret
WinMain endp

start:
  invoke GetModuleHandle,0
  invoke WinMain,eax,0,0,SW_SHOWDEFAULT
  invoke ExitProcess,eax
  invoke InitCommonControls  
end start
